//
//  TicTacToe_iOSAppDelegate.m
//  TicTacToe_iOS
//
//  Created by Spencer Hakim on 7/6/10.
//  Copyright Spencer Hakim 2010. All rights reserved.
//  License: http://www.gnu.org/licenses/gpl-3.0.txt
//

#import "TicTacToe_iOSAppDelegate.h"

//Comment out the following line to enable two-player mode
#define COMPUTERAI

@implementation TicTacToe_iOSAppDelegate

@synthesize window, button1, button2, button3, button4, button5, button6, button7, button8, button9, restartButton, turnLabel;

//used to calculate wins
static uint WinArray[8] = {7, 56, 73, 84, 146, 273, 292, 448};
static uint squareValues[9] = {1, 2, 4, 8, 16, 32, 64, 128, 256};

- (IBAction)button1Pressed {
	if( (XStatus & squareValues[0]) != 0 || (OStatus & squareValues[0]) != 0 )
		return;
	
	if( gameOver == YES )
		return;
	
	if( playerOneTurn == YES )
	{
		[turnLabel setText:@"Player Two's Turn"];
		[button1 setTitle:@"X" forState:UIControlStateNormal];
		playerOneTurn = NO;
		XStatus |= 1;
	}
	else
	{
		[turnLabel setText:@"Player One's Turn"];
		[button1 setTitle:@"O" forState:UIControlStateNormal];
		playerOneTurn = YES;
		OStatus |= 1;
	}
	
	[self checkForWinner];
	[self checkForTie];
	[self computerDoMove];
}

- (IBAction)button2Pressed {
	if( (XStatus & squareValues[1]) != 0 || (OStatus & squareValues[1]) != 0 )
		return;
	
	if( gameOver == YES )
		return;
	
	if( playerOneTurn == YES )
	{
		[turnLabel setText:@"Player Two's Turn"];
		[button2 setTitle:@"X" forState:UIControlStateNormal];
		playerOneTurn = NO;
		XStatus |= 2;
	}
	else
	{
		[turnLabel setText:@"Player One's Turn"];
		[button2 setTitle:@"O" forState:UIControlStateNormal];
		playerOneTurn = YES;
		OStatus |= 2;
	}
	
	[self checkForWinner];
	[self checkForTie];
	[self computerDoMove];
}

- (IBAction)button3Pressed {
	if( (XStatus & squareValues[2]) != 0 || (OStatus & squareValues[2]) != 0 )
		return;
	
	if( gameOver == YES )
		return;
	
	if( playerOneTurn == YES )
	{
		[turnLabel setText:@"Player Two's Turn"];
		[button3 setTitle:@"X" forState:UIControlStateNormal];
		playerOneTurn = NO;
		XStatus |= 4;
	}
	else
	{
		[turnLabel setText:@"Player One's Turn"];
		[button3 setTitle:@"O" forState:UIControlStateNormal];
		playerOneTurn = YES;
		OStatus |= 4;
	}
	
	[self checkForWinner];
	[self checkForTie];
	[self computerDoMove];
}

- (IBAction)button4Pressed {
	if( (XStatus & squareValues[3]) != 0 || (OStatus & squareValues[3]) != 0 )
		return;
	
	if( gameOver == YES )
		return;
	
	if( playerOneTurn == YES )
	{
		[turnLabel setText:@"Player Two's Turn"];
		[button4 setTitle:@"X" forState:UIControlStateNormal];
		playerOneTurn = NO;
		XStatus |= 8;
	}
	else
	{
		[turnLabel setText:@"Player One's Turn"];
		[button4 setTitle:@"O" forState:UIControlStateNormal];
		playerOneTurn = YES;
		OStatus |= 8;
	}
	
	[self checkForWinner];
	[self checkForTie];
	[self computerDoMove];
}

- (IBAction)button5Pressed {
	if( (XStatus & squareValues[4]) != 0 || (OStatus & squareValues[4]) != 0 )
		return;
	
	if( gameOver == YES )
		return;
	
	if( playerOneTurn == YES )
	{
		[turnLabel setText:@"Player Two's Turn"];
		[button5 setTitle:@"X" forState:UIControlStateNormal];
		playerOneTurn = NO;
		XStatus |= 16;
	}
	else
	{
		[turnLabel setText:@"Player One's Turn"];
		[button5 setTitle:@"O" forState:UIControlStateNormal];
		playerOneTurn = YES;
		OStatus |= 16;
	}
	
	[self checkForWinner];
	[self checkForTie];
	[self computerDoMove];
}

- (IBAction)button6Pressed {
	if( (XStatus & squareValues[5]) != 0 || (OStatus & squareValues[5]) != 0 )
		return;
	
	if( gameOver == YES )
		return;
	
	if( playerOneTurn == YES )
	{
		[turnLabel setText:@"Player Two's Turn"];
		[button6 setTitle:@"X" forState:UIControlStateNormal];
		playerOneTurn = NO;
		XStatus |= 32;
	}
	else
	{
		[turnLabel setText:@"Player One's Turn"];
		[button6 setTitle:@"O" forState:UIControlStateNormal];
		playerOneTurn = YES;
		OStatus |= 32;
	}
	
	[self checkForWinner];
	[self checkForTie];
	[self computerDoMove];
}

- (IBAction)button7Pressed {
	if( (XStatus & squareValues[6]) != 0 || (OStatus & squareValues[6]) != 0 )
		return;
	
	if( gameOver == YES )
		return;
	
	if( playerOneTurn == YES )
	{
		[turnLabel setText:@"Player Two's Turn"];
		[button7 setTitle:@"X" forState:UIControlStateNormal];
		playerOneTurn = NO;
		XStatus |= 64;
	}
	else
	{
		[turnLabel setText:@"Player One's Turn"];
		[button7 setTitle:@"O" forState:UIControlStateNormal];
		playerOneTurn = YES;
		OStatus |= 64;
	}
	
	[self checkForWinner];
	[self checkForTie];
	[self computerDoMove];
}

- (IBAction)button8Pressed {
	if( (XStatus & squareValues[7]) != 0 || (OStatus & squareValues[7]) != 0 )
		return;
	
	if( gameOver == YES )
		return;
	
	if( playerOneTurn == YES )
	{
		[turnLabel setText:@"Player Two's Turn"];
		[button8 setTitle:@"X" forState:UIControlStateNormal];
		playerOneTurn = NO;
		XStatus |= 128;
	}
	else
	{
		[turnLabel setText:@"Player One's Turn"];
		[button8 setTitle:@"O" forState:UIControlStateNormal];
		playerOneTurn = YES;
		OStatus |= 128;
	}
	
	[self checkForWinner];
	[self checkForTie];
	[self computerDoMove];
}

- (IBAction)button9Pressed {
	if( (XStatus & squareValues[8]) != 0 || (OStatus & squareValues[8]) != 0 )
		return;
	
	if( gameOver == YES )
		return;
	
	if( playerOneTurn == YES )
	{
		[turnLabel setText:@"Player Two's Turn"];
		[button9 setTitle:@"X" forState:UIControlStateNormal];
		playerOneTurn = NO;
		XStatus |= 256;
	}
	else
	{
		[turnLabel setText:@"Player One's Turn"];
		[button9 setTitle:@"O" forState:UIControlStateNormal];
		playerOneTurn = YES;
		OStatus |= 256;
	}
	
	[self checkForWinner];
	[self checkForTie];
	[self computerDoMove];
}

//reset the buttons, labels, and state variables
- (IBAction)restartButtonPressed {
	for(int i=0; i < 9; i++) {
		[buttonPointers[i] setTitle:@"" forState:UIControlStateNormal];
	}
	
	playerOneTurn = YES;
	gameOver = NO;
	XStatus = OStatus = 0;
	[turnLabel setText:@"Player One's Turn"];
	[restartButton setHidden:YES];
}

- (void)computerDoMove {
#ifdef COMPUTERAI
	if( gameOver == YES )
		return;
	
	int position = 0;
	
	//look for any winning moves for the computer and take it
	for(int i=0; i < 9; i++)
	{
		if( (XStatus & squareValues[i]) == squareValues[i] || (OStatus & squareValues[i]) == squareValues[i] )
			continue;
		
		int tempO = OStatus | squareValues[i];
		
		for(int j=0; j < 8; j++)
		{
			if( (tempO & WinArray[j]) == WinArray[j] )
			{
				//If O can win
				position = i;
				goto placemove; //Unfortunately, goto is the most straightforward way to break out of two nested for-loops
			}
		}
	}
	
	//look for any winning moves for the player and block it
	for(int i=0; i < 9; i++)
	{
		if( (OStatus & squareValues[i]) == squareValues[i] || (XStatus & squareValues[i]) == squareValues[i] )
			continue;
		
		int tempX = XStatus | squareValues[i];
		
		for(int j=0; j < 8; j++)
		{
			if( (tempX & WinArray[j]) == WinArray[j] )
			{
				//If X can win
				position = i;
				goto placemove; //Unfortunately, goto is the most straightforward way to break out of two nested for-loops
			}
		}
	}
	
	//find a random empty spot and take it
	while(YES)
	{
		int i = arc4random() % 9;
		if( (OStatus & squareValues[i]) != squareValues[i] && (XStatus & squareValues[i]) != squareValues[i])
		{
			//place piece randomly
			position = i;
			break;
		}
	}
	
placemove:
	[turnLabel setText:@"Player One's Turn"];
	[buttonPointers[position] setTitle:@"O" forState:UIControlStateNormal];
	playerOneTurn = YES;
	OStatus |= squareValues[position];
	
	[self checkForWinner];
	[self checkForTie];
#endif
}

//compare XStatus and OStatus to the array of precalculated wins
- (void)checkForWinner {
	for(int i=0; i < 8; i++) {
		if( (XStatus & WinArray[i]) == WinArray[i] ) {
			//X WINS
			[turnLabel setText:@"Player One Wins!"];
			gameOver = YES;
			[restartButton setHidden:NO];
		}
		
		if( (OStatus & WinArray[i]) == WinArray[i] ) {
			//O WINS
#ifdef COMPUTERAI
			[turnLabel setText:@"Computer Wins!"];
#else
			[turnLabel setText:@"Player Two Wins!"];
#endif
			gameOver = YES;
			[restartButton setHidden:NO];
		}
	}
}

//check for tie by checking for any empty spaces
- (void)checkForTie {
	for(int i=0; i < 9; i++) {
		if( (XStatus & squareValues[i]) == 0 && (OStatus & squareValues[i]) == 0 )
			return;
	}
	
	[turnLabel setText:@"The Game Is A Tie!"];
	gameOver = YES;
	[restartButton setHidden:NO];
}

#pragma mark -
#pragma mark Application lifecycle

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {    
    
    // Override point for customization after application launch.
    [window makeKeyAndVisible];
	
	//initialize state variables
	playerOneTurn = YES;
	gameOver = NO;
	XStatus = OStatus = 0;
	
	//build an array of the UIButton pointers to make things easy for the AI and the reset functionality
	buttonPointers[0] = button1;
	buttonPointers[1] = button2;
	buttonPointers[2] = button3;
	buttonPointers[3] = button4;
	buttonPointers[4] = button5;
	buttonPointers[5] = button6;
	buttonPointers[6] = button7;
	buttonPointers[7] = button8;
	buttonPointers[8] = button9;
	
	return YES;
}


- (void)applicationWillResignActive:(UIApplication *)application {
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}


- (void)applicationDidEnterBackground:(UIApplication *)application {
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, called instead of applicationWillTerminate: when the user quits.
     */
}


- (void)applicationWillEnterForeground:(UIApplication *)application {
    /*
     Called as part of  transition from the background to the inactive state: here you can undo many of the changes made on entering the background.
     */
}


- (void)applicationDidBecomeActive:(UIApplication *)application {
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
}


- (void)applicationWillTerminate:(UIApplication *)application {
    /*
     Called when the application is about to terminate.
     See also applicationDidEnterBackground:.
     */
}


#pragma mark -
#pragma mark Memory management

- (void)applicationDidReceiveMemoryWarning:(UIApplication *)application {
    /*
     Free up as much memory as possible by purging cached data objects that can be recreated (or reloaded from disk) later.
     */
}


- (void)dealloc {
    [window release];
    [super dealloc];
}

@end
