//
//  TicTacToe_iOSAppDelegate.h
//  TicTacToe_iOS
//
//  Created by Spencer Hakim on 7/6/10.
//  Copyright Spencer Hakim 2010. All rights reserved.
//  License: http://www.gnu.org/licenses/gpl-3.0.txt
//

#import <UIKit/UIKit.h>

@interface TicTacToe_iOSAppDelegate : NSObject <UIApplicationDelegate> {
    UIWindow *window;
	UIButton *button1, *button2, *button3, *button4, *button5, *button6, *button7, *button8, *button9;
	UIButton *restartButton;
	UIButton *buttonPointers[9]; //for the AI
	UILabel *turnLabel;
	
	BOOL playerOneTurn;
	BOOL gameOver;	
	uint XStatus;
	uint OStatus;
}

@property (nonatomic, retain) IBOutlet UIWindow *window;
@property (nonatomic, retain) IBOutlet UIButton *button1;
@property (nonatomic, retain) IBOutlet UIButton *button2;
@property (nonatomic, retain) IBOutlet UIButton *button3;
@property (nonatomic, retain) IBOutlet UIButton *button4;
@property (nonatomic, retain) IBOutlet UIButton *button5;
@property (nonatomic, retain) IBOutlet UIButton *button6;
@property (nonatomic, retain) IBOutlet UIButton *button7;
@property (nonatomic, retain) IBOutlet UIButton *button8;
@property (nonatomic, retain) IBOutlet UIButton *button9;
@property (nonatomic, retain) IBOutlet UIButton *restartButton;
@property (nonatomic, retain) IBOutlet UILabel *turnLabel;

- (IBAction)button1Pressed;
- (IBAction)button2Pressed;
- (IBAction)button3Pressed;
- (IBAction)button4Pressed;
- (IBAction)button5Pressed;
- (IBAction)button6Pressed;
- (IBAction)button7Pressed;
- (IBAction)button8Pressed;
- (IBAction)button9Pressed;
- (IBAction)restartButtonPressed;

- (void)checkForWinner;
- (void)checkForTie;
- (void)computerDoMove;

@end

